<?php
namespace SMSAdvert;

if ( ! defined( 'ABSPATH' ) )
	exit;

class Sender{
    public function __construct() {
        add_action('woocommerce_order_status_changed', [$this,'OrderStatusChanged'], 10, 3);
        add_action('woocommerce_new_order', [$this,'NewOrderCreated'], 10, 3);
        add_action('woocommerce_new_order', [$this,'NewOrderCreated'], 10, 3);
        
        add_action('woocommerce_new_customer_note', [$this,'NoteAdded'], 10, 3);
        
    }
    function NoteAdded($aArgs){
        if (isset($aArgs['order_id'])) {
            $sNote  = isset($aArgs['customer_note'])?$aArgs['customer_note']:'';
            $oOrder = wc_get_order($aArgs['order_id']);
            //if(get_option('sa_sender',true)=='smsadvert'){
                /*Send to Admin*/
                $sMessageOption = 'sa_admin_note_added_msg';
                $sEnabledOption = 'sa_admin_note_added_msg_enabled';
                if(get_option($sEnabledOption,true)==1??!empty(get_option('sa_owner_mobile_number',true))){
                    $sPhone = get_option('sa_owner_mobile_number',true);
                    $sMessage = get_option($sMessageOption,true);
                    $sMessage = $this->DoReplacements($sMessage, $oOrder);
                    $sMessage = str_replace('{NOTE}',$sNote,$sMessage );
                    self::SendSMS($sPhone,$sMessage);
                    $sLog = '';
                    $sLog .= "****************************\n";
                    $sLog .= "Sent to: Administrator\n";
                    $sLog .= "Phone: ".$sPhone."\n";
                    $sLog .= "Message: ".$sMessage."\n";
                    $sLog .= "****************************\n";
                    $sPrevLog= get_option('sa_log',true);
                    update_option('sa_log',$sLog.$sPrevLog);
                }
                /*Send to Customer*/
                $sMessageOption = 'sa_customer_note_added_msg';
                $sEnabledOption = 'sa_customer_note_added_msg_enabled';
                $sPhone = $oOrder->get_billing_phone();
                if(empty($sPhone)){
                    $sPhone = get_user_meta($oOrder->get_user_id(),'user_phone',true);
                }
                if(get_option($sEnabledOption,true)==1&&!empty($sPhone)){
                    $sMessage = get_option($sMessageOption,true);
                    $sMessage = $this->DoReplacements($sMessage, $oOrder);
                    $sMessage = str_replace('{NOTE}',$sNote,$sMessage );
                    self::SendSMS($sPhone,$sMessage);
                    $sLog = '';
                    $sLog .= "****************************\n";
                    $sLog .= "Sent to: Customer\n";
                    $sLog .= "Phone: ".$sPhone."\n";
                    $sLog .= "Message: ".$sMessage."\n";
                    $sLog .= "****************************\n";
                    $sPrevLog= get_option('sa_log',true);
                    update_option('sa_log',$sLog.$sPrevLog);
                }
                $sLog= get_option('sa_log',true);
                $aLogs = explode("****************************\n",$sLog);
                if(sizeof($aLogs)>20){
                    $aLogs = array_slice($aLogs, 0, 17);  
                    update_option('sa_log',implode("****************************\n",$aLogs));
                }
            //}
        }
    }
    function NewOrderCreated($iOrderID, $oOrder){
        //if(get_option('sa_sender',true)=='smsadvert'){
            /*Send to Admin*/
            $sMessageOption = 'sa_admin_order_created_msg';
            $sEnabledOption = 'sa_admin_order_created_msg_enabled';
            if(get_option($sEnabledOption,true)==1??!empty(get_option('sa_owner_mobile_number',true))){
                $sPhone = get_option('sa_owner_mobile_number',true);
                $sMessage = get_option($sMessageOption,true);
                $sMessage = $this->DoReplacements($sMessage, $oOrder);
                self::SendSMS($sPhone,$sMessage);
                $sLog = '';
                $sLog .= "****************************\n";
                $sLog .= "Sent to: Administrator\n";
                $sLog .= "Phone: ".$sPhone."\n";
                $sLog .= "Message: ".$sMessage."\n";
                $sLog .= "****************************\n";
                $sPrevLog= get_option('sa_log',true);
                update_option('sa_log',$sLog.$sPrevLog);
            }
            /*Send to Customer*/
            $sMessageOption = 'sa_customer_order_created_msg';
            $sEnabledOption = 'sa_customer_order_created_msg_enabled';
            $sPhone = $oOrder->get_billing_phone();
            if(empty($sPhone)){
                $sPhone = get_user_meta($oOrder->get_user_id(),'user_phone',true);
            }
            if(get_option($sEnabledOption,true)==1&&!empty($sPhone)){
                $sMessage = get_option($sMessageOption,true);
                $sMessage = $this->DoReplacements($sMessage, $oOrder);
                self::SendSMS($sPhone,$sMessage);
                $sLog = '';
                $sLog .= "****************************\n";
                $sLog .= "Sent to: Customer\n";
                $sLog .= "Phone: ".$sPhone."\n";
                $sLog .= "Message: ".$sMessage."\n";
                $sLog .= "****************************\n";
                $sPrevLog= get_option('sa_log',true);
                update_option('sa_log',$sLog.$sPrevLog);
            }
            $sLog= get_option('sa_log',true);
            $aLogs = explode("****************************\n",$sLog);
            if(sizeof($aLogs)>20){
                $aLogs = array_slice($aLogs, 0, 17);  
                update_option('sa_log',implode("****************************\n",$aLogs));
            }
        //}
    }
    protected function DoReplacements($sMessage,$oOrder){
        $aReplacements = [
            '{ORDER_ID}'=>$oOrder->get_id(),
            '{BILLING_FIRST_NAME}'=>$oOrder->get_billing_first_name(),
            '{BILLING_LAST_NAME}'=>$oOrder->get_billing_last_name(),
            '{BILLING_ADDRESS}'=>$oOrder->get_billing_address_1(),
            '{BILLING_CITY}'=>$oOrder->get_billing_city(),
            '{BILLING_STATE}'=>$oOrder->get_billing_state(),
            '{BILLING_ZIP}'=>$oOrder->get_billing_postcode(),
            '{BILLING_COUNTRY}'=>$oOrder->get_billing_country(),
            '{BILLING_EMAIL}'=>$oOrder->get_billing_email(),
            '{BILLING_PHONE}'=>$oOrder->get_billing_phone(),
            '{SHIPPING_FIRST_NAME}'=>$oOrder->get_shipping_first_name(),
            '{SHIPPING_LAST_NAME}'=>$oOrder->get_shipping_last_name(),
            '{SHIPPING_ADDRESS}'=>$oOrder->get_shipping_address_1(),
            '{SHIPPING_CITY}'=>$oOrder->get_shipping_city(),
            '{SHIPPING_STATE}'=>$oOrder->get_shipping_state(),
            '{SHIPPING_ZIP}'=>$oOrder->get_shipping_postcode(),
            '{SHIPPING_COUNTRY}'=>$oOrder->get_shipping_country(),
            '{SITE_NAME}'=> get_bloginfo('name'),
            '{ORDER_TOTAL}' => $oOrder->get_total(),
        ];
        foreach($aReplacements as $sLabel=>$sReplacement){
            $sMessage = str_replace($sLabel,$sReplacement,$sMessage);
        }
        return $sMessage;
    }
    function OrderStatusChanged($iOrderID, $old_status, $sNewStatus){
        //if(get_option('sa_sender',true)=='smsadvert'){
            $oOrder = wc_get_order( $iOrderID );
            /*Send to Admin*/
            $sMessageOption = 'sa_admin_order_'.str_replace('-','_',str_replace('wc-','',$sNewStatus)).'_msg';
            $sEnabledOption = 'sa_admin_order_'.str_replace('-','_',str_replace('wc-','',$sNewStatus)).'_msg_enabled';
            if(get_option($sEnabledOption,true)==1&&!empty(get_option('sa_owner_mobile_number',true))){
                $sPhone = get_option('sa_owner_mobile_number',true);
                $sMessage = get_option($sMessageOption,true);
                $sMessage = $this->DoReplacements($sMessage, $oOrder);
                self::SendSMS($sPhone,$sMessage);
                $sLog = '';
                $sLog .= "****************************\n";
                $sLog .= "Sent to: Administrator\n";
                $sLog .= "Phone: ".$sPhone."\n";
                $sLog .= "Message: ".$sMessage."\n";
                $sLog .= "****************************\n";
                $sPrevLog= get_option('sa_log',true);
                update_option('sa_log',$sLog.$sPrevLog);
            }
            /*Send to Customer*/
            $sMessageOption = 'sa_customer_order_'.str_replace('-','_',str_replace('wc-','',$sNewStatus)).'_msg';
            $sEnabledOption = 'sa_customer_order_'.str_replace('-','_',str_replace('wc-','',$sNewStatus)).'_msg_enabled';
            $sPhone = $oOrder->get_billing_phone();
            if(empty($sPhone)){
                $sPhone = get_user_meta($oOrder->get_user_id(),'user_phone',true);
            }
            if(get_option($sEnabledOption,true)==1&&!empty($sPhone)){
                $sMessage = get_option($sMessageOption,true);
                $sMessage = $this->DoReplacements($sMessage, $oOrder);
                self::SendSMS($sPhone,$sMessage);
                $sLog = '';
                $sLog .= "****************************\n";
                $sLog .= "Sent to: Customer\n";
                $sLog .= "Phone: ".$sPhone."\n";
                $sLog .= "Message: ".$sMessage."\n";
                $sLog .= "****************************\n";
                $sPrevLog= get_option('sa_log',true);
                update_option('sa_log',$sLog.$sPrevLog);
            }
            $sLog= get_option('sa_log',true);
            $aLogs = explode("****************************\n",$sLog);
            if(sizeof($aLogs)>20){
                $aLogs = array_slice($aLogs, 0, 17);  
                update_option('sa_log',implode("****************************\n",$aLogs));
            }
        //}
    }
    public static function SendSMS($sPhone, $sMessage) {
        // Sanitize the phone number
        $sPhone = trim(str_replace(['(', ')', '-', '.', ' '], '', $sPhone));
    
        // Prepare the data array
        $data = [
            'phone' => $sPhone,
            'shortTextMessage' => $sMessage,
            'sendAsShort' => (get_option('sa_sender', true) == 'smsadvert') ? true : false
        ];
    
        // Add failover conditionally
        if (get_option('sa_sender', true) == 'owndevices' && get_option('sa_send_use_smsadvert', true) == 1) {
            $data['failover'] = 'short';
        }
    
        // Convert the data array to JSON format with proper escaping
        $jsonPayload = json_encode($data);
    
        // Initialize cURL
        $hRes = curl_init();
        curl_setopt_array($hRes, array(
            CURLOPT_URL => 'https://www.smsadvert.ro/api/sms/',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => $jsonPayload,
            CURLOPT_HTTPHEADER => array(
                'Authorization: ' . get_option('sa_api_token', true),
                'Content-Type: application/json'
            ),
        ));
    
        // Execute the cURL request and get the response
        $sRes = curl_exec($hRes);
        curl_close($hRes);
    
        // Log the request and response
        $sPrevLog = get_option('sa_log', true);
        $sLog = "****************************\n";
        $sLog .= "API Request: " . $jsonPayload . "\n";
        $sLog .= "****************************\n";
        $sLog .= "API Answer: " . $sRes . "\n";
        $sLog .= "****************************\n";
        update_option('sa_log', $sLog . $sPrevLog);
    }
}
