<?php
namespace SMSAdvert;

if ( ! defined( 'ABSPATH' ) )
	exit;

class Settings{

    public function __construct() {
        add_action('admin_menu', [$this, 'RegisterOptionsPage']);
        add_action( 'admin_init', [$this, 'RegisterSettings']);
    }
    function RegisterSettings(){
        add_option('sa_api_token','');
        register_setting( 'sa_options_group', 'sa_api_token', 'cpl_callback' );
        add_option('sa_send_use_smsadvert',0);
        register_setting( 'sa_options_group', 'sa_send_use_smsadvert', 'cpl_callback' );
        
        
        add_option('sa_owner_mobile_number','');
        register_setting( 'sa_options_group', 'sa_owner_mobile_number', 'cpl_callback' );
        add_option('sa_sender','smsadvert');
        register_setting( 'sa_options_group', 'sa_sender', 'cpl_callback' );
        add_option('sa_log','');
        register_setting( 'sa_options_group', 'sa_log', 'cpl_callback' );
        /*Messages*/
        $aDefaultStatuses = ['pending','processing','on_hold','completed','cancelled','refunded','failed'];
        add_option('sa_admin_order_pending_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Pending.');
        register_setting( 'sa_options_group', 'sa_admin_order_pending_msg', 'cpl_callback' );
        add_option('sa_admin_order_processing_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Processing.');
        register_setting( 'sa_options_group', 'sa_admin_order_processing_msg', 'cpl_callback' );
        add_option('sa_admin_order_on_hold_msg','Your order No. {ORDER_ID} is received on {SHOP_NAME}. Thank you for shopping with us!');
        register_setting( 'sa_options_group', 'sa_admin_order_on_hold_msg', 'cpl_callback' );
        add_option('sa_admin_order_completed_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Completed.');
        register_setting( 'sa_options_group', 'sa_admin_order_completed_msg', 'cpl_callback' );
        add_option('sa_admin_order_cancelled_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Cancelled.');
        register_setting( 'sa_options_group', 'sa_admin_order_cancelled_msg', 'cpl_callback' );
        add_option('sa_admin_order_refunded_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Refunded.');
        register_setting( 'sa_options_group', 'sa_admin_order_refunded_msg', 'cpl_callback' );
        add_option('sa_admin_order_failed_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Failed.');
        register_setting( 'sa_options_group', 'sa_admin_order_failed_msg', 'cpl_callback' );
        
        $aStatuses = wc_get_order_statuses();
        if(is_array($aStatuses)){
            foreach($aStatuses as $sStatusSlug=>$sStatus){
                $sStatus = str_replace('-','_',str_replace('wc-','',$sStatusSlug));
                $sOption = 'sa_admin_order_'.str_replace('-','_',str_replace('wc-','',$sStatusSlug)).'_msg';
                $sEnabledOption = 'sa_admin_order_'.str_replace('-','_',str_replace('wc-','',$sStatusSlug)).'_msg_enabled';
                add_option($sEnabledOption,1);
                register_setting( 'sa_options_group', $sEnabledOption, 'cpl_callback' );
                if(!in_array($sStatus, $aDefaultStatuses)){
                    add_option($sOption,'');
                    register_setting( 'sa_options_group', $sOption, 'cpl_callback' );
                }
            }
        } 
        /*Messages*/
        $aDefaultStatuses = ['pending','processing','on_hold','completed','cancelled','refunded','failed'];
        add_option('sa_admin_order_created_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Created.');
        register_setting( 'sa_options_group', 'sa_admin_order_created_msg', 'cpl_callback' );
        add_option('sa_admin_order_created_msg_enabled',1);
        register_setting( 'sa_options_group', 'sa_admin_order_created_msg_enabled', 'cpl_callback' );
        
        
        add_option('sa_admin_note_added_msg','A note has been added: {NOTE}');
        register_setting( 'sa_options_group', 'sa_admin_note_added_msg', 'cpl_callback' );
        add_option('sa_admin_note_added_msg_enabled',1);
        register_setting( 'sa_options_group', 'sa_admin_note_added_msg_enabled', 'cpl_callback' );
        
        add_option('sa_customer_note_added_msg','A note has been added: {NOTE}');
        register_setting( 'sa_options_group', 'sa_customer_note_added_msg', 'cpl_callback' );
        add_option('sa_customer_note_added_msg_enabled',1);
        register_setting( 'sa_options_group', 'sa_customer_note_added_msg_enabled', 'cpl_callback' );
        
        
        add_option('sa_customer_order_created_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Created.');
        register_setting( 'sa_options_group', 'sa_customer_order_created_msg', 'cpl_callback' );
        add_option('sa_customer_order_created_msg_enabled',1);
        register_setting( 'sa_options_group', 'sa_customer_order_created_msg_enabled', 'cpl_callback' );
        
        add_option('sa_customer_order_pending_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Pending.');
        register_setting( 'sa_options_group', 'sa_customer_order_pending_msg', 'cpl_callback' );
        
        
        add_option('sa_customer_order_processing_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Processing.');
        register_setting( 'sa_options_group', 'sa_customer_order_processing_msg', 'cpl_callback' );
        add_option('sa_customer_order_on_hold_msg','Your order No. {ORDER_ID} is received on {SHOP_NAME}. Thank you for shopping with us!');
        register_setting( 'sa_options_group', 'sa_customer_order_on_hold_msg', 'cpl_callback' );
        add_option('sa_customer_order_completed_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Completed.');
        register_setting( 'sa_options_group', 'sa_customer_order_completed_msg', 'cpl_callback' );
        add_option('sa_customer_order_cancelled_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Cancelled.');
        register_setting( 'sa_options_group', 'sa_customer_order_cancelled_msg', 'cpl_callback' );
        add_option('sa_customer_order_refunded_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Refunded.');
        register_setting( 'sa_options_group', 'sa_customer_order_refunded_msg', 'cpl_callback' );
        add_option('sa_customer_order_failed_msg','Thank you for shopping with us! Your order No. {ORDER_ID} is now: Failed.');
        register_setting( 'sa_options_group', 'sa_customer_order_failed_msg', 'cpl_callback' );
        
        $aStatuses = wc_get_order_statuses();
        if(is_array($aStatuses)){
            foreach($aStatuses as $sStatusSlug=>$sStatus){
                $sStatus = str_replace('-','_',str_replace('wc-','',$sStatusSlug));
                $sOption = 'sa_customer_order_'.str_replace('-','_',str_replace('wc-','',$sStatusSlug)).'_msg';
                $sEnabledOption = 'sa_customer_order_'.str_replace('-','_',str_replace('wc-','',$sStatusSlug)).'_msg_enabled';
                add_option($sEnabledOption,1);
                register_setting( 'sa_options_group', $sEnabledOption, 'cpl_callback' );
                if(!in_array($sStatus, $aDefaultStatuses)){
                    add_option($sOption,'');
                    register_setting( 'sa_options_group', $sOption, 'cpl_callback' );
                }
            }
        } 
    }
    
 
    public function RegisterOptionsPage(){
      add_options_page(__('SMSAdvert','sms-advert'),__('SMSAdvert','sms-advert'), 'manage_options', 'formdata', [$this, 'OptionsPage']);
    }
    function OptionsPage(){
        $iCurrentTab = isset($_COOKIE['sa_current_tab'])?(int)$_COOKIE['sa_current_tab']:1;
        $sPath = SMSAdvert()->sPath;
        include $sPath.'templates/admin/settings.php';
    }
}





